const fs = require('fs');

const parser = {
  MODE_REGEX: 'mode_regex'
};

parser.getPasses = (phpfmt, mode = parser.MODE_REGEX) => {
  const code = fs.readFileSync(phpfmt.pharPath);
  const passes = [];

  if (mode === parser.MODE_REGEX) {
    const passRegex = /class\s+(\w+)\s+extends\s+(\w+)\s*\{/g;
    const allClasses = [];

    let match;
    while ((match = passRegex.exec(code)) !== null) {
      const parentCls = match[2];
      const cls = match[1];
      allClasses.push({
        parentCls: parentCls,
        cls: cls
      });
    }
    allClasses.forEach(cls => {
      if (cls.cls === 'AdditionalPass') {
        return;
      }
      if (
        cls.parentCls === 'AdditionalPass' ||
        cls.parentCls === 'FormatterPass'
      ) {
        passes.push(cls.cls);
      }
    });
    allClasses.forEach(cls => {
      if (passes.indexOf(cls.parentCls) > -1) {
        passes.push(cls.cls);
      }
    });
  } else {
    throw new Error(`Unknown mode: ${mode}`);
  }

  return passes;
};

parser.default = parser;

module.exports = exports = parser;
